var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Injectable } from '@angular/core';
import { HttpClient, HttpEventType } from '@angular/common/http';
import { ApolloLink, Observable as LinkObservable, } from 'apollo-link';
import { print } from 'graphql/language/printer';
import { mergeHeaders, prioritize, } from 'apollo-angular-link-http-common';
import { fetch } from './utils';
import extractFiles from 'extract-files';
// XXX find a better name for it
var 
// XXX find a better name for it
HttpLinkHandler = /** @class */ (function (_super) {
    __extends(HttpLinkHandler, _super);
    function HttpLinkHandler(httpClient, options) {
        var _this = _super.call(this) || this;
        _this.httpClient = httpClient;
        _this.options = options;
        _this.requester = function (operation) {
            return new LinkObservable(function (observer) {
                var context = operation.getContext();
                // decides which value to pick, Context, Options or to just use the default
                var pick = function (key, init) {
                    return prioritize(context[key], _this.options[key], init);
                };
                var includeQuery = pick('includeQuery', true);
                var includeExtensions = pick('includeExtensions', false);
                var method = pick('method', 'POST');
                var url = pick('uri', 'graphql');
                var withCredentials = pick('withCredentials');
                var requestOperation = {
                    operationName: operation.operationName,
                    variables: operation.variables,
                };
                if (includeExtensions) {
                    requestOperation.extensions = operation.extensions;
                }
                if (includeQuery) {
                    requestOperation.query = print(operation.query);
                }
                var body;
                var files = extractFiles(operation);
                if (files.length) {
                    // GraphQL multipart request spec:
                    // https://github.com/jaydenseric/graphql-multipart-request-spec
                    body = new FormData();
                    body.append('operations', JSON.stringify(requestOperation));
                    body.append('map', JSON.stringify(files.reduce(function (map, _a, index) {
                        var path = _a.path;
                        map["" + index] = [path];
                        return map;
                    }, {})));
                    files.forEach(function (_a, index) {
                        var file = _a.file;
                        // support for file name for Blob, (filename must be added as parameter)
                        // https://developer.mozilla.org/en-US/docs/Web/API/FormData/append
                        body.append(index, file, file.name);
                    });
                }
                else {
                    body = requestOperation;
                }
                var req = {
                    method: method,
                    url: url,
                    body: body,
                    options: {
                        withCredentials: withCredentials,
                        headers: _this.options.headers,
                    },
                };
                if (context.headers) {
                    req.options.headers = mergeHeaders(req.options.headers, context.headers);
                }
                var sub = fetch(req, _this.httpClient).subscribe(function (event) {
                    if (event.type === HttpEventType.UploadProgress && files.length && context.onUploadProgress) {
                        var progress = Math.round(100 * event.loaded / event.total);
                        context.onUploadProgress.next(progress);
                    }
                    else if (event.type === HttpEventType.Response) {
                        observer.next(event.body);
                        if (context.onUploadProgress) {
                            context.onUploadProgress.complete();
                        }
                    }
                }, function (err) { return observer.error(err); }, function () { return observer.complete(); });
                // const sub = fetch(req, this.httpClient).subscribe({
                //   next: result => observer.next(result.body),
                //   error: err => observer.error(err),
                //   complete: () => observer.complete(),
                // });
                return function () {
                    if (!sub.closed) {
                        sub.unsubscribe();
                    }
                };
            });
        };
        return _this;
    }
    HttpLinkHandler.prototype.request = function (op) {
        return this.requester(op);
    };
    return HttpLinkHandler;
}(ApolloLink));
// XXX find a better name for it
export { HttpLinkHandler };
var HttpLink = /** @class */ (function () {
    function HttpLink(httpClient) {
        this.httpClient = httpClient;
    }
    HttpLink.prototype.create = function (options) {
        return new HttpLinkHandler(this.httpClient, options);
    };
    HttpLink.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    HttpLink.ctorParameters = function () { return [
        { type: HttpClient, },
    ]; };
    return HttpLink;
}());
export { HttpLink };
//# sourceMappingURL=HttpLink.js.map