(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common/http'), require('rxjs'), require('@angular/core'), require('apollo-link'), require('graphql/language/printer'), require('apollo-angular-link-http-common'), require('extract-files')) :
    typeof define === 'function' && define.amd ? define(['exports', '@angular/common/http', 'rxjs', '@angular/core', 'apollo-link', 'graphql/language/printer', 'apollo-angular-link-http-common', 'extract-files'], factory) :
    (factory((global.apollo = global.apollo || {}, global.apollo.link = global.apollo.link || {}, global.apollo.link.http = {}),global.ng.common.http,null,global.ng.core,global.httpLink,global.graphql.printer,null,global['extract-files']));
}(this, (function (exports,http,rxjs,core,apolloLink,printer,apolloAngularLinkHttpCommon,extractFiles) { 'use strict';

    extractFiles = extractFiles && extractFiles.hasOwnProperty('default') ? extractFiles['default'] : extractFiles;

    var __assign = (undefined && undefined.__assign) || Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    var fetch = function (req, httpClient) {
        var shouldUseBody = ['POST', 'PUT', 'PATCH'].indexOf(req.method.toUpperCase()) !== -1;
        var shouldStringify = function (param) {
            return ['variables', 'extensions'].indexOf(param.toLowerCase()) !== -1;
        };
        // `body` for some, `params` for others
        var bodyOrParams = {};
        if (req.body.length) {
            if (!shouldUseBody) {
                return new rxjs.Observable(function (observer) {
                    return observer.error(new Error('Batching is not available for GET requests'));
                });
            }
            bodyOrParams = {
                body: req.body,
            };
        }
        else {
            if (shouldUseBody) {
                bodyOrParams = {};
            }
            else {
                Object.keys(req.body).forEach(function (param) {
                    if (shouldStringify(param.toLowerCase())) {
                        req.body[param] = JSON.stringify(req.body[param]);
                    }
                });
                bodyOrParams = { params: req.body };
            }
        }
        var _req = new http.HttpRequest(req.method, req.url, req.body, __assign({ responseType: 'json', reportProgress: true }, req.options, bodyOrParams));
        // create a request
        return httpClient.request(_req);
    };

    var __extends = (undefined && undefined.__extends) || (function () {
        var extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    // XXX find a better name for it
    var  
    // XXX find a better name for it
    HttpLinkHandler = /** @class */ (function (_super) {
        __extends(HttpLinkHandler, _super);
        function HttpLinkHandler(httpClient, options) {
            var _this = _super.call(this) || this;
            _this.httpClient = httpClient;
            _this.options = options;
            _this.requester = function (operation) {
                return new apolloLink.Observable(function (observer) {
                    var context = operation.getContext();
                    // decides which value to pick, Context, Options or to just use the default
                    var pick = function (key, init) {
                        return apolloAngularLinkHttpCommon.prioritize(context[key], _this.options[key], init);
                    };
                    var includeQuery = pick('includeQuery', true);
                    var includeExtensions = pick('includeExtensions', false);
                    var method = pick('method', 'POST');
                    var url = pick('uri', 'graphql');
                    var withCredentials = pick('withCredentials');
                    var requestOperation = {
                        operationName: operation.operationName,
                        variables: operation.variables,
                    };
                    if (includeExtensions) {
                        requestOperation.extensions = operation.extensions;
                    }
                    if (includeQuery) {
                        requestOperation.query = printer.print(operation.query);
                    }
                    var body;
                    var files = extractFiles(operation);
                    if (files.length) {
                        // GraphQL multipart request spec:
                        // https://github.com/jaydenseric/graphql-multipart-request-spec
                        body = new FormData();
                        body.append('operations', JSON.stringify(requestOperation));
                        body.append('map', JSON.stringify(files.reduce(function (map, _a, index) {
                            var path = _a.path;
                            map["" + index] = [path];
                            return map;
                        }, {})));
                        files.forEach(function (_a, index) {
                            var file = _a.file;
                            // support for file name for Blob, (filename must be added as parameter)
                            // https://developer.mozilla.org/en-US/docs/Web/API/FormData/append
                            body.append(index, file, file.name);
                        });
                    }
                    else {
                        body = requestOperation;
                    }
                    var req = {
                        method: method,
                        url: url,
                        body: body,
                        options: {
                            withCredentials: withCredentials,
                            headers: _this.options.headers,
                        },
                    };
                    if (context.headers) {
                        req.options.headers = apolloAngularLinkHttpCommon.mergeHeaders(req.options.headers, context.headers);
                    }
                    var sub = fetch(req, _this.httpClient).subscribe(function (event) {
                        if (event.type === http.HttpEventType.UploadProgress && files.length && context.onUploadProgress) {
                            var progress = Math.round(100 * event.loaded / event.total);
                            context.onUploadProgress.next(progress);
                        }
                        else if (event.type === http.HttpEventType.Response) {
                            observer.next(event.body);
                            if (context.onUploadProgress) {
                                context.onUploadProgress.complete();
                            }
                        }
                    }, function (err) { return observer.error(err); }, function () { return observer.complete(); });
                    // const sub = fetch(req, this.httpClient).subscribe({
                    //   next: result => observer.next(result.body),
                    //   error: err => observer.error(err),
                    //   complete: () => observer.complete(),
                    // });
                    return function () {
                        if (!sub.closed) {
                            sub.unsubscribe();
                        }
                    };
                });
            };
            return _this;
        }
        HttpLinkHandler.prototype.request = function (op) {
            return this.requester(op);
        };
        return HttpLinkHandler;
    }(apolloLink.ApolloLink));
    var HttpLink = /** @class */ (function () {
        function HttpLink(httpClient) {
            this.httpClient = httpClient;
        }
        HttpLink.prototype.create = function (options) {
            return new HttpLinkHandler(this.httpClient, options);
        };
        HttpLink.decorators = [
            { type: core.Injectable },
        ];
        /** @nocollapse */
        HttpLink.ctorParameters = function () { return [
            { type: http.HttpClient, },
        ]; };
        return HttpLink;
    }());

    var PROVIDERS = [HttpLink];
    var HttpLinkModule = /** @class */ (function () {
        function HttpLinkModule() {
        }
        HttpLinkModule.decorators = [
            { type: core.NgModule, args: [{
                        providers: PROVIDERS,
                    },] },
        ];
        return HttpLinkModule;
    }());

    exports.HttpLink = HttpLink;
    exports.HttpLinkHandler = HttpLinkHandler;
    exports.HttpLinkModule = HttpLinkModule;
    exports.PROVIDERS = PROVIDERS;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=bundle.umd.js.map
