var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
import { HttpRequest } from '@angular/common/http';
import { Observable } from 'rxjs';
export var fetch = function (req, httpClient) {
    var shouldUseBody = ['POST', 'PUT', 'PATCH'].indexOf(req.method.toUpperCase()) !== -1;
    var shouldStringify = function (param) {
        return ['variables', 'extensions'].indexOf(param.toLowerCase()) !== -1;
    };
    // `body` for some, `params` for others
    var bodyOrParams = {};
    if (req.body.length) {
        if (!shouldUseBody) {
            return new Observable(function (observer) {
                return observer.error(new Error('Batching is not available for GET requests'));
            });
        }
        bodyOrParams = {
            body: req.body,
        };
    }
    else {
        if (shouldUseBody) {
            bodyOrParams = {};
        }
        else {
            Object.keys(req.body).forEach(function (param) {
                if (shouldStringify(param.toLowerCase())) {
                    req.body[param] = JSON.stringify(req.body[param]);
                }
            });
            bodyOrParams = { params: req.body };
        }
    }
    var _req = new HttpRequest(req.method, req.url, req.body, __assign({ responseType: 'json', reportProgress: true }, req.options, bodyOrParams));
    // create a request
    return httpClient.request(_req);
};
//# sourceMappingURL=utils.js.map